//package com.muyu.rule.load;
//
//import com.muyu.rule.scan.JavaCodeScan;
//import io.jsonwebtoken.io.IOException;
//import org.slf4j.Logger;
//import org.slf4j.LoggerFactory;
//
//import java.io.File;
//import java.io.FileNotFoundException;
//import java.nio.file.Files;
//import java.util.HashMap;
//import java.util.Map;
//
///**
// * @ClassName Java   java字节码加载器
// * @Description 加载
// * @Author Chen
// * @Date 2024/8/23 09:55
// */
//public class JavaBinaryClassLoader extends ClassLoader {
//    private static JavaBinaryClassLoader loader = new JavaBinaryClassLoader();
//
//    private static final Logger log = LoggerFactory.getLogger(JavaBinaryClassLoader.class);
//
//
//    /**
//     * @param name     class 类的文件名
//     * @param pack     类所在的包名
//     * @param location 类文件的路径
//     * @return
//     */
//    private static Class<?> loadClassByNameAndLocation(String name, String pack, File location) {
//        byte[] datas = null;
//        try {
//            datas = loader.loadClassData(name, location);
//        } catch (Exception e) {
//            throw new RuntimeException(e);
//        }
//        pack = loader.convert(pack);
//        Class<?> aClass = loader.defineClass(pack + name, datas, 0, datas.length);
//        log.info("成功加载规则引擎->{}", aClass.getName());
//        return aClass;
//    }
//
//    /**
//     * @param pack     类所在的包名   后面需要 "."
//     * @param location 包所在的路径
//     * @return
//     */
//    public static Map<String, Class<?>> loadClassesByLocation(String pack, String location) {
//        File[] childFiles = JavaCodeScan.javaBinaryByPath(location);
//        HashMap<String, Class<?>> map = new HashMap<>();
//        for (File f : childFiles) {
//            String name = f.getName().substring(0, f.getName().indexOf(".class"));
//            Class<?> c = loadClassByNameAndLocation(name, pack, new File(location));
//            map.put(name, c);
//        }
//        return map;
//    }
//
//
//    public byte[] loadClassData(String name, File location) throws Exception {
//        File classFile = new File(location, name + ".class");
//        if (!classFile.exists()) {
//            throw new FileNotFoundException("找不到类文件: " + classFile.getAbsolutePath());
//        }
//        return Files.readAllBytes(classFile.toPath());
//    }
//
//    public String convert(String pack) {
//        return pack;
//    }
//
//}
